unit Unit1;

{$MODE Delphi}

interface

uses
  LCLIntf, LCLType, LMessages, Messages, SysUtils, Classes, Graphics, IntfGraphics,
  Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Buttons, Menus, FileUtil;

type

  { TForm1 }

  TForm1 = class(TForm)
    Tab: TTabControl;
    Image1: TImage;
    Image2: TImage;
    Bar: TProgressBar;
    Panel1: TPanel;
    SaveDialog1: TSaveDialog;
    Button1: TButton;
    GroupBox1: TGroupBox;
    Edit4: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Button3: TButton;
    GroupBox2: TGroupBox;
    Edit5: TEdit;
    GroupBox3: TGroupBox;
    ComboBox1: TComboBox;
    Label3: TLabel;
    Edit3: TEdit;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Button4: TButton;
    CheckBox5: TCheckBox;
    UpDown1: TUpDown;
    Edit6: TEdit;
    Edit9: TEdit;
    Edit10: TEdit;
    Shape1: TShape;
    Label9: TLabel;
    ColorDialog1: TColorDialog;
    Edit12: TEdit;
    Image3: TImage;
    CheckBox6: TCheckBox;
    UpDown2: TUpDown;
    Edit1: TEdit;
    Label2: TLabel;
    Shape2: TShape;
    Timer1: TTimer;
    GroupBox4: TGroupBox;
    CheckBox7: TCheckBox;
    CheckBox9: TCheckBox;
    CheckBox8: TCheckBox;
    Edit13: TEdit;
    imgLeg: TImage;
    Edit14: TEdit;
    TrackBar1: TTrackBar;
    Label4: TLabel;
    Button2: TSpeedButton;
    Label7: TLabel;
    Button6: TSpeedButton;
    Label1: TLabel;
    SpeedButton1: TSpeedButton;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Command1: TMenuItem;
    Help1: TMenuItem;
    ExportFont1: TMenuItem;
    LoadProject1: TMenuItem;
    N2: TMenuItem;
    Exit1: TMenuItem;
    RedrawFont1: TMenuItem;
    GenerateMask1: TMenuItem;
    N3: TMenuItem;
    mi1: TMenuItem;
    mi2: TMenuItem;
    mi3: TMenuItem;
    SetUpCharacterRange1: TMenuItem;
    About1: TMenuItem;
    UpDown3: TUpDown;
    UpDown4: TUpDown;
    UpDown5: TUpDown;
    Edit11: TEdit;
    UpDown6: TUpDown;
    OpenDialog1: TOpenDialog;
    CheckBox3: TCheckBox;
    imgLeg2: TImage;
    UpDown7: TUpDown;
    UpDown8: TUpDown;
    TrackBar2: TTrackBar;
    Timer2: TTimer;
    mi4: TMenuItem;
    procedure mi4Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure Image3DblClick(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure LoadProject1Click(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure CheckBox8Click(Sender: TObject);
    procedure mi3Click(Sender: TObject);
    procedure mi2Click(Sender: TObject);
    procedure mi1Click(Sender: TObject);
    procedure ExportFont1Click(Sender: TObject);
    procedure SetUpCharacterRange1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure GenerateMask1Click(Sender: TObject);
    procedure RedrawFont1Click(Sender: TObject);
    procedure CheckBox9Click(Sender: TObject);
    procedure Edit12Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Shape2MouseUp(Sender: TObject; Button: TMouseButton;  Shift: TShiftState; X, Y: Integer);
    procedure FormResize(Sender: TObject);
    procedure CheckBox7Click(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
    procedure Edit7Change(Sender: TObject);
    procedure Edit8Change(Sender: TObject);
    procedure DrawFont(Col, Col2: integer);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure TabChange(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure Edit9Change(Sender: TObject);
    procedure Edit6Change(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure p(Sender: TObject; Button: TMouseButton;  Shift: TShiftState; X, Y: Integer);
    procedure Edit11Change(Sender: TObject);
  private
    procedure UpdateFont;
    Procedure ResizeImage3(X,Y: integeR);

    { Private declarations }
  public
    OnceOffPErformanceTest, NoChange, NeedDraw, Masked: boolean;
    Highest, Longest, SpaceWidth: integer;
    Procedure SaveStudioData(fs: TFilestream);
    Procedure LoadStudioData(fs: TFilestream);
    { Public declarations }
  end;

  FontRec = Record
            T1,U1,T2,U2, W, H, KernW: single;
            end;
  StudioData = record
      FontName: array[0..50] of char;
      Size: integer;
      Bold, Italic, AutoSize, Drop, Stretch, AutoMask, AutoPreview, ShowGuide: boolean;
      FG, BG, PreviewCol: integer;
      Columns, TexSize, Smooth, Offset, Opacity: integer;
      StartChar, EndChar, Wid, Hgt, VPad, Lead, Trail, Kern: integer;

  end;
var
  Form1: TForm1;
  Var F: array of FontRec;
  I: integer;
  CurSize, CharS, CharE, PreviewCol: integer;
implementation

uses Unit2, Grids, Math;

{$R *.lfm}

Procedure ScanFonts;
Var I: integer;
begin

 For I := 0 to Screen.fonts.Count -1 do
  Form1.ComboBox1.Items.Add(screen.Fonts.Strings[I]);

 CharS := 33;
 CharE := 150;
end;

Procedure ChangeTab(Num: integer);
begin
 Form1.Tab.TabIndex := Num;
 Case Form1.Tab.TabIndex of
 0: begin
      Form1.Image1.Visible := True;
      Form1.Image2.Visible := False;
    end;
 1: begin
      Form1.Image1.Visible := False;
      Form1.Image2.Visible := True;
    end;
 end;
 Application.ProcessMessages;


end;

procedure TForm1.About1Click(Sender: TObject);
begin
  Button6.Click;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  NoChange := true;
  Masked := false;

  Label7.Caption := 'Status: Calculating Font...';
  Application.ProcessMessages;


  UpdateFont;

  if NeedDraw then
  begin
    NeedDraw := false;
    Label7.Caption := 'Status: Rendering Font...';
    Application.ProcessMessages;
    DrawFont(Shape1.Brush.Color, Shape2.brush.color);

   if Checkbox8.Checked then
   begin
     button3.Click;
   end;

  end;

  if Checkbox9.Checked then
  begin
    button4.Click;
  end;

  Label7.Caption := 'Status: Idle';
  Application.ProcessMessages;

  NoChange := false;

end;

procedure TForm1.UpdateFont;
Var X, Y, W, H, t1, t2, t4, t5, t7, t8, T13, T14, T11: integer;

    C, NewT7, NewT8: integer;
Label Redo;
begin
 NoChange := true;
 W := Image1.Picture.Width-1;
 H := Image1.Picture.Height-1;

 if CharE < CharS then CharE := CharS + 1;
 if CharE > 255 then CharE := 255;
 if CharS > CharE then CharS := CharE - 1;
 if CharS < 0 then CharS := 0;
 Edit9.text := inttostr(CharS);
 Edit6.text := inttostr(CharE);

 if length(F) <> (CharE-CharS)+1 then
 SetLength(F, (CharE-CharS)+1);

 Redo:

 Highest := 0;
 Longest := 0;

 With Image1.Picture.Bitmap.canvas do
 begin
  Pen.Color := 0;
  Font.Name := Combobox1.Text;
  Font.Size := strtoint(edit3.text);
  Font.Style := [];
  if checkbox1.checked then font.Style := [fsBold];
  if checkbox2.checked then font.Style := font.style + [fsItalic];

 end;


 t1 := Updown2.Position;  //Num Columns
 t7 := strtoint(edit7.text);  //Width
 t8 := strtoint(edit8.text);  //Height
 t4 := strtoint(edit4.text);  //Verticle Pad
 t5 := strtoint(edit5.text);  //Shadow Offset
 t2 := Trackbar2.Position;  //Shadow Blur
 T13 := strtoint(edit13.Text); //Trailing;
 T14 := strtoint(edit14.Text); //Leading;
 T11 := strtoint(edit11.Text); //Kerning


 SpaceWidth := Image1.Picture.Bitmap.Canvas.TextWidth(' ')+T11;
 For C := CharS to charE do
 begin
  X := ((C-CharS) mod t1) * t7+1;
  Y := ((C-CharS) div t1) * t8;
  F[C-CharS].T1 := X/W;
  F[C-CharS].U1 := Y/H;
  F[C-CharS].W := round(Image1.Picture.Bitmap.Canvas.TextWidth(char(C))+T13+T14)+t5;
  F[C-CharS].H := round(Image1.Picture.Bitmap.Canvas.TextHeight(char(C))+T4)+t5;

  if F[C-CharS].W > Longest then
  Longest := round(F[C-CharS].W);
  if F[C-CharS].H > Highest then
  Highest := round(F[C-CharS].H);


  F[C-CharS].T2 := (X+F[C-CharS].W)/W;
  F[C-CharS].U2 := (Y+F[C-CharS].H)/H;

  F[C-CharS].KernW := Image1.Picture.Bitmap.Canvas.TextWidth(char(C))+T11/10;

 end;


  if Checkbox6.Checked then
  begin

   NewT7 := (Longest+T13+T14);
   NewT8 := (Highest+T4);
   Edit7.Text := inttostr(NewT7);
   Edit8.Text := inttostr(NewT8);
   W := Image1.Picture.Width-1;
   Updown2.Position := trunc(W / (Longest+T13+T14));

   if (T7 <> NewT7) or (T8 <> NewT8) or (T1 <> UpDown2.Position) then
   begin
    NeedDraw := true;
    goto Redo;
   end;

  end;


 image3.height := (Highest+4);
 Image3.Top := edit12.Top - 4 - (Image3.Height);
 Tab.Height := Image3.Top - Tab.Top - 4;
 ResizeImage3(image3.Width, image3.Height);
 NoChange := false;
end;

procedure TForm1.DrawFont(Col, Col2: integer);
Var X, Y, W, H, T14, T4, X2, Y2: integer;

    C: integer;
begin
 NoChange := true;
 W := Image1.Picture.Width-1;
 H := Image1.Picture.Height-1;

 if Col2 = 0 then
 //BitBlt(DestDC: HDC; X, Y, Width, Height: Integer; SrcDC: HDC; XSrc, YSrc: Integer; Rop: DWORD):
  BitBlt(Image1.Picture.Bitmap.Canvas.Handle, 0, 0, W+3, H+3, Image1.Picture.Bitmap.Canvas.Handle,0,0, BLACKNESS)
 else
 With Image1.Picture.Bitmap.canvas do
 begin
   Brush.Color := Col2;
   Pen.Color := col2;
   Rectangle(0,0,W+3, H+3);
 end;


 With Image1.Picture.Bitmap.canvas do
 begin
  Pen.Color := 0;
  Font.Color := Col;
  Brush.Color := Col2;
 end;

 T14 := strtoint(edit14.Text); //Leading;
  t4 := strtoint(edit4.text);  //Verticle Pad


 For C := CharS to charE do
 begin
  X := round(F[C-CharS].T1*W)+T14;
  Y := Round(F[C-CharS].U1*H+T4*0.5);

   Image1.Picture.Bitmap.Canvas.TextOut(X,Y, char(C));

 end;

 if Checkbox3.Checked then
 begin
 With Image1.Picture.Bitmap.canvas do
 begin
   Brush.Style := bsClear;
   Pen.Color := clGray;
   Pen.Mode := pmXOr;
 end;

 For C := CharS to charE do
 begin
  X := round(F[C-CharS].T1*W);
  Y := Round(F[C-CharS].U1*H);
  X2 := round(F[C-CharS].T2*W);
  Y2 := Round(F[C-CharS].U2*H);

  Image1.Picture.Bitmap.Canvas.Rectangle(X, Y, X2, Y2);
 end;

 With Image1.Picture.Bitmap.canvas do
 begin
   Brush.Style := bsSolid;
   Pen.Mode := pmCopy;
 end;
 end;

 NoChange := false;
end;

Procedure SaveTGA(filename: string);
var
  JPG: TJPEGimage;
  Other: string;

begin
  form1.label7.caption := 'Status: Generating Font';
  form1.Button1.Click;
  form1.label7.caption := 'Status: Generating Hi-Quality Mask';
  form1.Button3.click;
  application.ProcessMessages;

  jpg := TJpegimage.Create;
  Jpg.CompressionQuality := 100;
  With Jpg do
  begin
   // Jpg.Grayscale := false;
    Assign(form1.Image1.picture.bitmap);
    SaveToFile(Filename);

    application.ProcessMessages;

   // Jpg.Grayscale := true;
    Other := copy(Filename, 1, length(filename)-3) + 'jpg';
    Assign(Form1.image2.Picture.Bitmap);
    SavetoFile(Other);
  end;

  Jpg.Free;

  form1.Bar.Position := 0;
end;

procedure TForm1.Button2Click(Sender: TObject);
Var Fi, F2: TFileStream;
    I, Data: integer;
    Filename, Other: string;
    EndPos, CutPos: longint;
    Od: boolean;
begin
 Checkbox3.Checked := false;

 od := Checkbox8.Checked;
 Checkbox8.Checked := true;


 SaveDialog1.FilterIndex := 1;
 SaveDialog1.Title := 'Save Font File';
 if SaveDialog1.Execute then
 begin
  try
  Filename := Savedialog1.filename;
  if pos('.', Savedialog1.filename) > 0 then
  begin
    I := pos('.', Savedialog1.filename);
    if uppercase(Copy(Savedialog1.filename, I+1, 3)) <> 'FNT' then
    filename := copy(filename, 1, I) + 'fnt';
  end
  else
  begin
    filename := savedialog1.filename + '.fnt';
  end;

    SaveTGA(FileName);
    Other := Copy(filename, 1, length(Filename)-3)+'jpg';
  F2 := TFileStream.Create(Other, fmOpenRead);

  Fi := TFileStream.Create(filename, fmOpenWrite);
   CutPos := Fi.Seek(0, soFromEnd);
   Fi.CopyFrom(F2, 0);
   F2.free;

   EndPos := Fi.Seek(0, soFromEnd);


  label7.caption := 'Status: Saving Font File';
  Data := High(F);
  Fi.Write(Data, sizeof(integer)); //Size of Font Array
  Data := strtoint(edit9.Text);
  Fi.Write(Data, sizeof(integer)); //Start Character
  Data := strtoint(edit5.Text)+Trackbar2.Position;
  Fi.Write(Data, sizeof(integer)); //Smooth Stuff
  Data := SpaceWidth;
  Fi.Write(Data, sizeof(integer)); //Space Width;

  For I := 0 to high(F) do
  begin
    Fi.Write(F[I], sizeof(FontRec));
  end;

  SaveStudioData(Fi);

  Fi.Write(CutPos, sizeof(longint));
  Fi.Write(EndPos, sizeof(longint));

  Fi.Free;
  DeleteFileUTF8(Other); { *Converted from DeleteFile* }
  label7.caption := 'Status: Saved Successfully!';
  except
   on E:Exception do
   begin
     Showmessage('An Error Occured!'+#13+#13+E.Message);
     label7.caption := 'Status: Save Failed!';
   end;
  end;

  end;

 Checkbox8.Checked := Od;

end;

procedure TForm1.RedrawFont1Click(Sender: TObject);
begin
button1.Click;
end;

procedure TForm1.ResizeImage3(X, Y: integeR);
begin
      Image3.Picture.Bitmap.Width := X;
      Image3.Picture.Bitmap.Height := y;
      Image3.Picture.Bitmap.Canvas.Pen.Color := clBtnFace;
      Image3.Picture.Bitmap.Canvas.Rectangle(0,0,X,Y);

end;

procedure TForm1.FormCreate(Sender: TObject);
Var X,Y: integer;
begin
  PreviewCol := clBtnFace;
  ScanFonts;
  Doublebuffered := true;
      CurSize := 3;
      X:=512;Y:=X;
      OnceOffPErformanceTest := true;
      Image1.Picture.Bitmap.Width := X;
      Image1.Picture.Bitmap.Height := y;
      Image2.Picture.Bitmap.Width := X;
      Image2.Picture.Bitmap.Height := y;
      image1.Picture.Bitmap.PixelFormat := pf24bit;
      image2.Picture.Bitmap.PixelFormat := pf24bit;
      image3.Picture.Bitmap.PixelFormat := pf24bit;

     // patblt(Image1.Picture.Bitmap.Canvas.Handle, 0, 0, X, Y, BLACKNESS);
      BitBlt(Image1.Picture.Bitmap.Canvas.Handle, 0, 0, X, Y, Image1.Picture.Bitmap.Canvas.Handle, 0, 0,BLACKNESS);

    //  patblt(Image2.Picture.Bitmap.Canvas.Handle, 0, 0, X, Y, BLACKNESS);
      BitBlt(Image2.Picture.Bitmap.Canvas.Handle, 0, 0, X, Y, Image2.Picture.Bitmap.Canvas.Handle, 0, 0,BLACKNESS);

      ResizeImage3(image3.Width, image3.Height);

      changeTab(0);
      Button1.Click;

end;

procedure TForm1.FormResize(Sender: TObject);
begin
      ResizeImage3(image3.Width, image3.Height);

end;

procedure TForm1.GenerateMask1Click(Sender: TObject);
begin
    Button3.Click;
end;

procedure TForm1.Image3DblClick(Sender: TObject);
begin
  if ColorDialog1.Execute then
  begin
    PreviewCol := ColorDialog1.Color;
    Button4.Click;
  end;
end;

procedure TForm1.SaveStudioData(fs: TFilestream);
Var Std: StudioData;
    I, C: integer;
    Siz: cardinal;
begin
  for I := 0 to min(Length(Combobox1.Text), 50) do
   Std.FontName[I] := Combobox1.text[I];

  std.Size := strtoint(edit3.Text);
  std.Bold := Checkbox1.Checked;
  std.Italic := Checkbox2.Checked;
  std.Columns := strtoint(edit1.Text);
  std.AutoSize := checkbox6.Checked;
  std.FG := shape1.Brush.Color;
  std.BG := shape2.Brush.Color;
  std.Drop := checkbox5.Checked;
  std.TexSize := trackbar1.Position;
  std.Stretch := checkbox7.Checked;
  std.AutoMask := checkbox8.Checked;
  std.AutoPreview := checkbox9.Checked;
  std.Smooth := Trackbar2.Position;
  std.Offset := strtoint(edit5.Text);
  std.Opacity := strtoint(edit10.Text);
  std.Wid := strtoint(edit7.Text);
  std.StartChar := strtoint(edit9.Text);
  std.EndChar := strtoint(edit6.Text);
  std.Hgt := strtoint(edit8.Text);
  std.VPad := strtoint(edit4.Text);
  std.Lead := strtoint(edit14.Text);
  std.Trail := strtoint(edit13.Text);
  std.Kern := strtoint(edit11.Text);
  std.PreviewCol := PreviewCol;
  std.ShowGuide := Checkbox3.Checked;

  C := $F0;
  Siz := sizeof(StudioData);
  Fs.Write(C, sizeof(integer));
  Fs.Write(Siz, sizeof(Cardinal));
  Fs.Write(Std, Sizeof(StudioData));

end;

procedure TForm1.LoadStudioData(fs: TFilestream);
var C, I: integer;
    Siz: cardinal;
    Std: StudioData;
    S: string;
begin
   C := $00;
   try
    if Fs.Size > Fs.Position then
       Fs.Read(C, sizeof(integer));
    if C <> $F0 then
      Messagebox(handle, 'This file does not contain any studio data. It cannot be loaded into the studio.', 'File Error', MB_OK or MB_ICONERROR)
    else
    begin
     Fs.Read(Siz, sizeof(cardinal));
     if sizeof(StudioData) <> Siz then
     begin
        Messagebox(handle, PAnsiChar('This file is from a different version of font studio. It cannot be loaded into the studio.'+#13+'Record size mismatch: '+inttostr(Siz)+' should be '+inttostr(sizeof(std))), 'File Error', MB_OK or MB_ICONERROR);
        exit;
     end;

     Fs.Read(Std, SizeoF(StudioData));

   S := '';
   For I := 0 to 50 do
   begin
      S := S + Std.FontName[I];
   end;
   Combobox1.Text := Trim(S);


   edit3.Text := inttostr(std.Size);
   Checkbox3.Checked := std.ShowGuide;
   PreviewCol := std.PreviewCol;
   Checkbox1.Checked := std.Bold ;
   Checkbox2.Checked := std.Italic ;
   edit1.Text := inttostr(std.Columns)   ;
   checkbox6.Checked := std.AutoSize     ;
   shape1.Brush.Color :=  std.FG         ;
   shape2.Brush.Color :=  std.BG        ;
   checkbox5.Checked :=  std.Drop          ;
   trackbar1.Position := std.TexSize        ;
   checkbox7.Checked := std.Stretch          ;
   checkbox8.Checked := std.AutoMask          ;
   checkbox9.Checked :=   std.AutoPreview     ;
   Trackbar2.position :=  std.Smooth       ;
   edit5.Text :=  inttostr(std.Offset)       ;
   edit10.Text :=   inttostr(std.Opacity)    ;
   edit7.Text :=   inttostr(std.Wid)         ;
   edit9.Text :=    inttostr(std.StartChar)    ;
   edit6.Text :=    inttostr(std.EndChar)      ;
   edit8.Text :=  inttostr(std.Hgt)             ;
   edit4.Text :=  inttostr(std.VPad)                 ;
   edit14.Text :=   inttostr(std.Lead)              ;
   edit13.Text :=  inttostr(std.Trail)               ;
   edit11.Text :=  inttostr(std.Kern)   ;

   Timer1.Enabled := true;
    end;
   except

   end;
end;


procedure TForm1.LoadProject1Click(Sender: TObject);
var f: TFileStream;
    stPos: Longint;
    Data: integer;
begin

  if OpenDialog1.execute then
  begin
     F := TFileStream.Create(opendialog1.filename, fmOpenRead);
      F.Seek(-(sizeof(longint)), soFromEnd);
      F.Read(Stpos, sizeof(longint));
      F.Seek(Stpos, soFromBeginning);

      F.Read(Data, Sizeof(integer));
      F.Seek(sizeof(integer)*3+sizeof(FontRec)*(Data+1), soFromCurrent);

      LoadStudioData(F);
     F.Free;
  end;

end;

procedure TForm1.mi1Click(Sender: TObject);
begin
  Checkbox7.Checked := Checkbox7.Checked = false;
  mi1.Checked := checkbox7.Checked;

end;

procedure TForm1.mi2Click(Sender: TObject);
begin
  Checkbox8.Checked := Checkbox8.Checked = false;
  mi2.Checked := checkbox8.Checked;

end;

procedure TForm1.mi3Click(Sender: TObject);
begin
  Checkbox9.Checked := Checkbox9.Checked = false;
  mi3.Checked := checkbox9.Checked;

end;

procedure TForm1.mi4Click(Sender: TObject);
begin
 Checkbox3.Checked := (Checkbox3.Checked = false);
  mi4.Checked := checkbox3.Checked;

end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
 Timer1.Enabled := true;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
 if (Edit1.text = '') or (Edit1.text = '0') then
 begin
  Edit1.selstart := Length(Edit1.text);
  Edit1.text := '1';
 end;
 Edit1.text := inttostr(strtoint(edit1.text));
 if Not NoChange then Timer1.Enabled := true;

end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
  Masked := false;
end;

procedure TForm1.Edit3Change(Sender: TObject);

begin
 if (Edit3.text = '') or (Edit3.text = '0') then
 begin
 end
 else
 begin
 Edit3.text := inttostr(strtoint(edit3.text));

   Timer1.Enabled := true;
 end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
 Button1.Click;

end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
 Button1.Click;

end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
 mi4.Checked := checkbox3.Checked;
 Timer1.Enabled := true;

end;

procedure TForm1.Edit4Change(Sender: TObject);
begin
 if TEdit(Sender).text <> '' then
 begin
  if Not NoChange then Timer1.Enabled := true;
 end;

end;

procedure TForm1.Edit7Change(Sender: TObject);
begin
// if Not NoChange then Timer1.Enabled := true;
end;

procedure TForm1.Edit8Change(Sender: TObject);
begin
// if Not NoChange then Timer1.Enabled := true;

end;

Procedure GetSize(Var C, X, Y: integer);
begin
  case C of
  0: begin X:=256;Y:=256; End;
  1: begin X:=512;Y:=256; End;
  2: begin X:=256;Y:=512; End;
  3: begin X:=512;Y:=512; End;
  4: begin X:=1024;Y:=512; End;
  5: begin X:=512;Y:=1024; End;
  6: begin X:=1024;Y:=1024; End;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
Var X,Y, R, G, B, Xx, Yy, Tot, Smt, Off: integer;
    LastTime: cardinal;
    V, Sat: single;
    i1, i2: PByteArray;
    xbmp1,xbmp2:TLazIntfImage;
begin
try
  NoChange := true;
//  changeTab(1);
   Masked := true;
   Edit12.Visible := false;

   if (Shape1.Brush.Color <> clWhite) or (Shape2.Brush.Color <> 0) then
   DrawFont(clWhite, 0);

   Off := Strtoint(edit5.text);
   Tot := Image1.Picture.Height*2;
   Smt := Trackbar2.Position;
   Sat := strtoint(Edit10.text)/100;

  // patblt(Image2.Picture.Bitmap.Canvas.Handle, 0, 0, Image2.Picture.Width, Image2.Picture.Height, BLACKNESS);
   BitBlt(Image2.Picture.Bitmap.Canvas.Handle, 0, 0, Image2.Picture.Width, Image2.Picture.Height, Image2.Picture.Bitmap.Canvas.Handle, 0, 0,BLACKNESS);

   Image2.Repaint;
   image2.Refresh;
 try
  LastTime := GetTickCount;

  if Checkbox5.checked then
  begin
   label7.caption := 'Status: Drop Shadow...';
   Application.ProcessMessages;
   image2.Canvas.Draw(Off,Off,image1.Picture.Bitmap);

   xbmp2:=image2.Picture.Bitmap.CreateIntfImage;

   For Y := 0 to Image1.Picture.Height-1 do
   begin
     //i2 := image2.Picture.Bitmap.ScanLine[Y];
     i2 := xBmp2.GetDataLineStart(y);

     for X := 0 to Image1.Picture.Width-1 do
     begin

        R := 0;
        G := 0;
        for YY := Y-Smt to Y+Smt do
        if (YY >= 0) and (YY < image2.picture.Height) then
        begin
        //   i1 := image2.Picture.Bitmap.ScanLine[YY];
         i1 := xBmp2.GetDataLineStart(YY);

           for XX := X-Smt to X+Smt do
           if (xx >= 0) and (Xx < image2.picture.Width) then
           begin
              R := R + i1[XX*3];
              inc(G);
           end;
        end;
        R := R div G;
        if Sat < 1 then R := Round(R*Sat);
        i2[X*3  ] := R;
        i2[X*3+1] := R;
        i2[X*3+2] := R;
     end;

   if (GetTickCount - LastTime > 500) then
    begin
     LastTime := GetTickCount;
     Image2.Repaint;
     image2.Refresh;
     Application.ProcessMessages;
     Bar.Position := round(Y/Tot*100);
    end;

   end;

   image2.Picture.Bitmap.LoadFromIntfImage(xbmp2);
   xbmp2.free;
  end;

//...........................................................

   label7.caption := 'Status: Generating Mask';
   Application.ProcessMessages;

   xbmp1:=image1.Picture.Bitmap.CreateIntfImage;
   xbmp2:=image2.Picture.Bitmap.CreateIntfImage;

   For Y := 0 to Image1.Picture.Height-1 do
   begin
  // i1 := image1.Picture.Bitmap.ScanLine[Y];
    i1 := xBmp1.GetDataLineStart(Y);
  // i2 := image2.Picture.Bitmap.ScanLine[Y];
    i1 := xBmp2.GetDataLineStart(Y);

   for X := 0 to Image1.Picture.Width-1 do
   begin
      V := i1[X*3];
      V := V/255;
      if V >= 0.004 then
      begin
       R := i1[X*3];
       G := i2[X*3+1];
       B := i1[X*3+2];

       if (R > G) and (R > B) then B := R
       else if (G > R) and (G > B) then B := G;

       G := i2[X*3];
       R := round(G*(1-V)+B*V);
       i2[X*3] := R;
       i2[X*3+1] := R;
       i2[X*3+2] := R;
      end;
   end;

   if (GetTickCount - LastTime > 500) then
    begin
     LastTime := GetTickCount;
     Image2.Repaint;
     image2.Refresh;
     Application.ProcessMessages;
     Bar.Position := round(Y/Tot*100)+50;
    end;


   end;

   image2.Picture.Bitmap.LoadFromIntfImage(xbmp2);
   xbmp1.free;
   xbmp2.free;

   Image2.Repaint;
   image2.Refresh;

   Bar.Position := 0;
   if (Shape1.Brush.Color <> clWhite) or (Shape2.Brush.Color <> 0) then
     DrawFont(Shape1.Brush.color, Shape2.Brush.Color);
   Edit12.Visible := true;
      label7.caption := 'Status: Idle';

   if Checkbox9.Checked then Button4.Click;

  except
  end;

finally
  NoChange := false;
end;

end;


Procedure DrawTest;
Var X,Y,W, H, R, G, B: integer;
    CurX, CurY, Sx, Sy, Ex, Ey, Tx, Ty: integer;
    V: single;
    Pa, Pb, Pc: PByteArray;
    Stri: string;
    xbmp1,xbmp2,xbmp3:TLazIntfImage;
begin

  if Not Form1.Masked then
  begin
     Form1.Masked := true;
     Form1.Button3.Click;
  end;

 // With Form1.Image3.Picture.bitmap do
 // begin
   // GetSize(CurSize, W, H);
     Form1.Image3.Picture.bitmap.GetSize(W, H);

     Form1.Image3.Picture.bitmap.Canvas.Brush.Color := PreviewCol;
     Form1.Image3.Picture.bitmap.Canvas.Pen.Style  := psClear;

     Form1.Image3.Picture.bitmap.Canvas.Rectangle(0,0,form1.image3.width+2,form1.image3.height+2);

     Curx := 10;
     Cury := 2;
     Stri := Form1.Edit12.Text;

   if Form1.Edit12.Text = '' then exit;
   form1.label7.caption := 'Status: Rendering Test...';

    xbmp1:=Form1.image1.Picture.Bitmap.CreateIntfImage;
    xbmp2:=Form1.image2.Picture.Bitmap.CreateIntfImage;
    xbmp3:=Form1.image3.Picture.Bitmap.CreateIntfImage;

   repeat
    if ord(Stri[1]) <> 32 then
    begin
     Sx := round(F[ord(Stri[1])-CharS].T1*W);
     Sy := round(F[ord(Stri[1])-CharS].U1*H);
     Ex := trunc(F[ord(Stri[1])-CharS].T2*W);
     Ey := trunc(F[ord(Stri[1])-CharS].U2*H);



     for Y := Sy to Ey do
     if (Y > 0) and (Y < form1.image1.picture.height-1) then
     begin

     // Pa := Image1.Picture.Bitmap.ScanLine[Y];
        Pa := xBmp1.GetDataLineStart(Y);
     // Pb := Image2.Picture.Bitmap.ScanLine[Y];
        Pb := xBmp2.GetDataLineStart(Y);

     for X := Sx to Ex do
     if (X > 0) and (X < form1.image1.picture.Width-1) then
     Begin
        V := Pb[X*3]/256;
        if V > 0.0077821011673151750972762645914397 then
        begin

         try
          Ty := form1.Image3.height-(CurY-(Y-Ey));
          if (Ty > 0) and (Ty < form1.image3.height) then
          begin
           Tx := (CurX+(X-Sx))*3;
        // Pc := scanline[Ty];
           Pc := xBmp3.GetDataLineStart(Ty);

           R := round(Pc[Tx]*(1-V)+Pa[X*3]*V);
           G := round(Pc[Tx+1]*(1-V)+Pa[X*3+1]*V);
           B := round(Pc[Tx+2]*(1-V)+Pa[X*3+2]*V);
           Pc[Tx  ] := R;
           Pc[Tx+1] := G;
           Pc[Tx+2] := B;
          end;
         except

         end;
        end;
     end;
     end;

   CurX := CurX + round(F[ord(Stri[1])-CharS].KernW);


   end
   else
    CurX := curX + Form1.SpaceWidth;


   Stri := Copy(Stri, 2, length(Stri));
   until (Stri = '') or (CurX+form1.Longest > form1.image3.width);
 // end;

   Form1.image3.Picture.Bitmap.LoadFromIntfImage(xbmp3);
   xbmp1.free;
   xbmp2.free;
   xbmp3.free;

  form1.Image3.Refresh;
  form1.Image3.Repaint;


  form1.label7.caption := 'Status: Idle';
  form1.Bar.Position := 0;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  DrawTest;
end;

procedure TForm1.TabChange(Sender: TObject);
begin
 ChangeTab(Tab.Tabindex);
end;



procedure TForm1.Timer1Timer(Sender: TObject);
begin
 if NoChange = false then
 begin
  Timer1.Enabled := false;
  NeedDraw := true;
  Button1.Click;
 end;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
 if NoChange = false then
 begin
   Timer2.Enabled := false;
   Button3.Click;
 end;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
Var X, Y, cnt: integer;
begin
case Trackbar1.Position of
0:
Label4.caption := 'Texture Size: 256x256';
1:
Label4.caption := 'Texture Size: 512x256';
2:
Label4.caption := 'Texture Size: 256x512';
3:
Label4.caption := 'Texture Size: 512x512';
4:
Label4.caption := 'Texture Size: 1024x512';
5:
Label4.caption := 'Texture Size: 512x1024';
6:
Label4.caption := 'Texture Size: 1024x1024';
end;
   Cnt := 0;
   repeat
    sleep(1);
    inc(Cnt);
   until (NoChange = false) or (Cnt > 1000);

   if CurSize <> Trackbar1.Position then
   begin
      CurSize := Trackbar1.Position;
      GetSize(CurSize, X,Y);
      Image1.Picture.Bitmap.Width := X;
      Image1.Picture.Bitmap.Height := y;
      Image2.Picture.Bitmap.Width := X;
      Image2.Picture.Bitmap.Height := y;

     //patblt(Image1.Picture.Bitmap.Canvas.Handle, 0, 0, X, Y, BLACKNESS);
      BitBlt(Image1.Picture.Bitmap.Canvas.Handle, 0, 0, X, Y, Image1.Picture.Bitmap.Canvas.Handle, 0, 0,BLACKNESS);

     //patblt(Image2.Picture.Bitmap.Canvas.Handle, 0, 0, X, Y, BLACKNESS);
      BitBlt(Image2.Picture.Bitmap.Canvas.Handle, 0, 0, X, Y, Image2.Picture.Bitmap.Canvas.Handle, 0, 0,BLACKNESS);

      if Not NoChange then Timer1.Enabled := true;
   end;

end;


procedure TForm1.TrackBar2Change(Sender: TObject);
begin
  Masked := false;
  Timer2.Enabled := true;
end;

procedure TForm1.CheckBox5Click(Sender: TObject);
var C: integer;
begin
  for C := 0 to Groupbox2.ControlCount-1 do
  begin
    Groupbox2.Controls[C].Enabled := Checkbox5.Checked;
  end;

  Masked := false;

  Timer2.Enabled := true;

end;

procedure TForm1.CheckBox6Click(Sender: TObject);
begin
  Updown2.Enabled := not checkbox6.Checked;
  Edit7.Enabled := not checkbox6.Checked;
  Edit8.Enabled := not checkbox6.Checked;
  edit1.Enabled := not checkbox6.Checked;
end;

procedure TForm1.CheckBox7Click(Sender: TObject);
begin
  image1.Stretch := checkbox7.Checked;
  image2.Stretch := checkbox7.Checked;
     mi1.Checked := checkbox7.Checked;

end;

procedure TForm1.CheckBox8Click(Sender: TObject);
begin
   mi2.Checked := checkbox8.Checked;
   if Checkbox8.Checked = false then
      Checkbox9.Checked := false;
   timer1.Enabled := true;
end;

procedure TForm1.CheckBox9Click(Sender: TObject);
begin
   if Checkbox9.Checked then Checkbox8.Checked := true;
   mi3.Checked := checkbox9.Checked;
   button4.Click;
end;

procedure TForm1.Edit9Change(Sender: TObject);
begin
 if (Edit9.text = '') or (Edit9.text = '0') then
 begin
 end
 else
 begin
  CharS := strtoint(edit9.text);
  edit9.text := inttostr(Chars);
  if Not NoChange then Timer1.Enabled := true;

 end;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Halt(1);
end;

procedure TForm1.ExportFont1Click(Sender: TObject);
begin
  Button2.Click;
end;

procedure TForm1.Edit6Change(Sender: TObject);
begin
 if (Edit6.text = '') or (Edit6.text = '0') then
 begin
 end
 else
 begin
  CharE := strtoint(edit6.text);
  edit6.text := inttostr(CharE);
  if Not NoChange then Timer1.Enabled := true;

 end;

end;

procedure TForm1.Button6Click(Sender: TObject);
begin
 Messagebox(form1.handle, 'Font Studio 3'+#13#13+
 '(C) 2003-2006 Michael Pote.'+#13#13+'Visit www.nitrogen.za.org.', 'About Font Studio', MB_OK or MB_ICONINFORMATION);
end;

procedure TForm1.SetUpCharacterRange1Click(Sender: TObject);
begin
  Speedbutton1.Click;
end;

procedure TForm1.Shape2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if Colordialog1.Execute then
 begin
    Shape2.Brush.Color := colordialog1.Color;
    if Not NoChange then Timer1.Enabled := true;

 end;

end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
Var GSel: TGridRect;
begin
   UpdateFont;
   form2.LabeledEdit1.text := edit9.Text;
   form2.LabeledEdit2.text := edit6.Text;

   GSel.Left := 0;
   GSel.Top := strtoint(Edit9.Text);
   GSel.Right := 1;
   GSel.Bottom := strtoint(Edit6.Text);

   Form2.grid.Selection := GSel;
   Form2.grid.TopRow := GSel.Top;


   if Form2.ShowModal = mrOk then
   begin
     edit9.Text := form2.LabeledEdit1.text;
     edit6.Text := form2.LabeledEdit2.text;
   end;
end;

procedure TForm1.p(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if Colordialog1.Execute then
 begin
    Shape1.Brush.Color := colordialog1.Color;
    if Not NoChange then Timer1.Enabled := true;

 end;
end;

procedure TForm1.Edit11Change(Sender: TObject);
begin
   Timer1.Enabled := true;
end;

procedure TForm1.Edit12Change(Sender: TObject);
begin
  if checkbox9.Checked then
     button4.Click;
end;

end.
